diff -uNr PDFlib-Lite-7.0.4/libs/pdcore/pc_prefix.h PDFlib-Lite-7.0.5/libs/pdcore/pc_prefix.h
--- PDFlib-Lite-7.0.4/libs/pdcore/pc_prefix.h	2009-06-08 17:57:28.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdcore/pc_prefix.h	2010-04-29 15:50:05.000000000 +0200
@@ -6,7 +6,7 @@
  |          Proprietary source code -- do not redistribute!                  |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pc_prefix.h,v 1.31.2.7 2009/04/29 19:16:44 serge Exp $
+/* $Id: pc_prefix.h,v 1.31.2.11 2010/04/26 09:53:19 kurt Exp $
  *
  * PDCORE: unique renaming of function names shared by different applications
  */
diff -uNr PDFlib-Lite-7.0.4/libs/pdcore/pc_resource.c PDFlib-Lite-7.0.5/libs/pdcore/pc_resource.c
--- PDFlib-Lite-7.0.4/libs/pdcore/pc_resource.c	2009-06-08 17:57:28.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdcore/pc_resource.c	2010-04-29 15:50:05.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pc_resource.c,v 1.61.2.48 2009/04/01 20:48:29 kurt Exp $
+/* $Id: pc_resource.c,v 1.61.2.55 2010/04/22 14:37:52 kurt Exp $
  *
  * Resource routines
  *
@@ -227,7 +227,7 @@
     char **linelist;
     char *line;
     char *category = NULL;
-    char *uprfilename = NULL;
+    const char *uprfilename = NULL;
     char tmpname[PDC_FILENAMELEN];
     char prodname[32];
     char prodversion[32];
@@ -333,7 +333,7 @@
 
     for (il = 0; rootdirectories[il] != NULL; il++)
     {
-        const char *home = pdc_getenv("HOME");
+        const char *home = pdc_getenv_filename(pdc, "HOME");
 
         if (home != NULL)
              sprintf(tmpname, rootdirectories[il], home);
@@ -354,13 +354,13 @@
 #endif /* !WIN32 && !AS400 && !MVS */
 
     /* searching for name of upr file */
-    uprfilename = (char *)filename;
+    uprfilename = filename;
     if (uprfilename == NULL || *uprfilename == '\0')
     {
         /* upr file name via environment variable */
         sprintf(tmpname, RESOURCEFILEENVNAME, pdc->prodname);
         pdc_strtoupper(tmpname);
-        uprfilename = pdc_getenv(tmpname);
+        uprfilename = pdc_getenv(pdc, tmpname);
 
 #ifdef WIN32
         /* registry upr file name */
@@ -1178,8 +1178,8 @@
 pdc_new_logg(pdc_core *pdc)
 {
     static const char fn[] = "pdc_new_logg";
+    const char *filename;
     char envname[32];
-    const char *envval = NULL;
 
     pdc_loggdef *logg = (pdc_loggdef *)
                               pdc_malloc(pdc, sizeof(pdc_loggdef), fn);
@@ -1203,11 +1203,11 @@
     /* logging file name defined by environment variable */
     sprintf(envname, LOGFILEENVNAME, pdc->prodname);
     pdc_strtoupper(envname);
-    envval = pdc_getenv(envname);
-    if (envval != NULL)
+    filename = pdc_getenv(pdc, envname);
+    if (filename != NULL)
     {
-        logg->filename = pdc_strdup(pdc, envval);
-        logg->fromenviron = pdc_true;
+        logg->filename = pdc_strdup(pdc, filename);
+        logg->fromenviron = pdc_undef; /* not yet initialized */
     }
 
     return logg;
@@ -1380,7 +1380,7 @@
 
         pdc_get_optvalues("remove", resopts, &remfile, NULL);
 
-        if (!logg->fromenviron)
+        if (logg->fromenviron == pdc_false)
         {
             const char *fname = pdc_get_opt_filename(pdc, "filename", resopts);
 
@@ -1462,16 +1462,22 @@
         else
         {
             strcpy(filename, logg->filename);
+            if (logg->fromenviron == pdc_undef)
+            {
+                logg->fromenviron = pdc_true;
+                pdc_free(pdc, logg->filename);
+                logg->filename = NULL;
+            }
         }
     }
 
     /* new logging file */
-    if (logg->filename == NULL || strcmp(logg->filename, filename))
+    if (pdc_strcmp(logg->filename, filename))
     {
         pdc_time ltime;
 
         /* close file */
-        if (logg->fp != stdout && logg->fp != stderr && logg->filename)
+        if (logg->fp != stdout && logg->fp != stderr && logg->filename != NULL)
         {
             pdc_localtime(&ltime);
             pdc_logg(pdc, "[%04d-%02d-%02d %02d:%02d:%02d]\n",
@@ -1556,7 +1562,7 @@
 
             if (logg->classapi)
             {
-                strcpy(buf, "[ Use  %%s/\\[[^]]*\\]//g  and  %%s/)$/);"
+                strcpy(buf, "[ Use  %s/\\[[^]]*\\]//g  and  %s/)$/);"
                              "/  in vi to compile it");
                 i = MAX(PDC_SEPARSTR_LEN - (int) strlen(buf) - 1, 1);
                 pdc_logg(pdc, "%s%*s]\n", buf, i, " ");
@@ -1653,7 +1659,7 @@
             pdc->loggenv = pdc_true;
             sprintf(envname, LOGGINGENVNAME, pdc->prodname);
             pdc_strtoupper(envname);
-            envval = pdc_getenv(envname);
+            envval = pdc_getenv(pdc, envname);
             if (envval != NULL)
             {
                 pdc_set_logg_options(pdc, envval);
@@ -1747,8 +1753,10 @@
 void
 pdc_logg_enable(pdc_core *pdc, pdc_bool enable)
 {
-    if (pdc != NULL && pdc->logg != NULL)
+    if (pdc != NULL && pdc->logg != NULL && pdc->logg->filename != NULL)
+    {
         pdc->logg->enabled = enable;
+    }
 }
 
 /*
diff -uNr PDFlib-Lite-7.0.4/libs/pdcore/pc_scope.c PDFlib-Lite-7.0.5/libs/pdcore/pc_scope.c
--- PDFlib-Lite-7.0.4/libs/pdcore/pc_scope.c	2009-06-08 17:57:28.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdcore/pc_scope.c	2010-04-29 15:50:05.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pc_scope.c,v 1.110.2.42 2009/05/11 14:44:19 rjs Exp $
+/* $Id: pc_scope.c,v 1.110.2.48 2010/04/22 09:16:26 rjs Exp $
  *
  * Scoping routines and macros
  *
diff -uNr PDFlib-Lite-7.0.4/libs/pdcore/pc_util.c PDFlib-Lite-7.0.5/libs/pdcore/pc_util.c
--- PDFlib-Lite-7.0.4/libs/pdcore/pc_util.c	2009-06-08 17:57:28.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdcore/pc_util.c	2010-04-29 15:50:05.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pc_util.c,v 1.209.2.64 2009/04/29 19:16:44 serge Exp $
+/* $Id: pc_util.c,v 1.209.2.69 2010/04/21 18:58:46 kurt Exp $
  *
  * PDFlib various utility routines
  *
@@ -34,11 +34,15 @@
 #define PDC_ISFINITE isfinite
 #else /* isfinite */
 
-#ifdef _WIN32
+#if defined(WIN32)
+#if !defined(_UNICODE)
+#define UNICODE
+#endif
 #include <windows.h>
 #include <float.h>
+#include <wchar.h>
 #define PDC_ISFINITE _finite
-#else /* _WIN32 */
+#else /* WIN32 */
 
 #ifdef OS_ZOS_SASC
 #define PDC_ISFINITE isfinite
@@ -315,17 +319,73 @@
 /* -------------------------- Environment ------------------------------ */
 
 char *
-pdc_getenv(const char *name)
+pdc_getenv(pdc_core *pdc, const char *envname)
 {
+    char *envvalue = NULL;
+
+    (void) pdc;
+    (void) envname;
+
 #ifdef HAVE_ENVVARS
-    return getenv(name);
-#else
-    (void) name;
+    envvalue = getenv(envname);
+    if (envvalue != NULL)
+    {
+        pdc_logg_cond(pdc, 1, trc_filesearch,
+            "\tEnvironment variable \"%s=%s\"\n", envname, envvalue);
+    }
+#endif /* HAVE_ENVVARS */
 
-    return (char *) 0;
-#endif
+    return envvalue;
 }
 
+char *
+pdc_getenv_filename(pdc_core *pdc, const char *envname)
+{
+    static const char fn[] = "pdc_getenv_filename";
+    char *envvalue = NULL;
+    int flags = PDC_CONV_TMPALLOC;
+
+#if defined(WIN32)
+
+    size_t len = strlen(envname), wlen;
+    const wchar_t *wenvvalue;
+    wchar_t *wenvname;
+
+    DWORD nSize = PDC_FILENAMELEN;
+
+    wlen = 2 * (len + 1);
+    wenvname = (wchar_t *) pdc_calloc(pdc, wlen, fn);
+    pdc_inflate_ascii(envname, (int) len, (char *) wenvname, pdc_utf16);
+
+    wenvvalue = _wgetenv(wenvname);
+    pdc_free(pdc, wenvname);
+
+    if (wenvvalue != NULL && pdc_wstrlen((char *) wenvvalue))
+    {
+        wlen = 2 * wcslen(wenvvalue);
+        pdc_logg_cond(pdc, 1, trc_filesearch,
+            "\tEnvironment variable \"%s=%T\"\n", envname, wenvvalue, wlen);
+
+        if (pdc_logg_is_enabled(pdc, 3, trc_filesearch))
+            flags |= PDC_CONV_LOGGING;
+
+        envvalue = pdc_convert_name(pdc, (char *) wenvvalue, wlen, flags);
+    }
+
+#else /* WIN32 */
+
+    envvalue = pdc_getenv(pdc, envname);
+    if (envvalue != NULL && strlen(envvalue))
+    {
+        envvalue = pdc_strdup_ext(pdc, envvalue, flags, fn);
+    }
+
+#endif /* !WIN32 */
+
+    return envvalue;
+}
+
+
 
 /* ------------------------ Language Code ------------------------------ */
 
@@ -2571,7 +2631,7 @@
 
 		len = strlen(cstr);
 
-                if (prec != -1 && prec < len)
+                if (prec != -1 && prec < (int) len)
 		{
 		    len = prec;
 		}
diff -uNr PDFlib-Lite-7.0.4/libs/pdcore/pc_util.h PDFlib-Lite-7.0.5/libs/pdcore/pc_util.h
--- PDFlib-Lite-7.0.4/libs/pdcore/pc_util.h	2009-06-08 17:57:28.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdcore/pc_util.h	2010-04-29 15:50:05.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pc_util.h,v 1.107.2.35 2009/04/29 19:16:44 serge Exp $
+/* $Id: pc_util.h,v 1.107.2.38 2010/04/21 18:51:22 kurt Exp $
  *
  * Declaration of various utility routines
  *
@@ -206,23 +206,24 @@
 
 size_t  pdc_wstrlen(const char *str);
 size_t  pdc_strlen(const char *str);
-char	*pdc_getenv(const char *name);
-char    *pdc_strdup_ext(pdc_core *pdc, const char *text, int flags,
+char *pdc_getenv(pdc_core *pdc, const char *envname);
+char *pdc_getenv_filename(pdc_core *pdc, const char *envname);
+char   *pdc_strdup_ext(pdc_core *pdc, const char *text, int flags,
                 const char *fn);
-char    *pdc_strdup(pdc_core *pdc, const char *text);
-char	*pdc_strdup2(pdc_core *pdc, const char *text, size_t len);
-char    *pdc_strdup_tmp(pdc_core *pdc, const char *text);
+char   *pdc_strdup(pdc_core *pdc, const char *text);
+char   *pdc_strdup2(pdc_core *pdc, const char *text, size_t len);
+char   *pdc_strdup_tmp(pdc_core *pdc, const char *text);
 int     pdc_convert_pascal_str(const char *pstr, char *cstr);
 pdc_bool pdc_logg_isprint(int c);
-char    *pdc_strprint(pdc_core *pdc, const char *str, int leni,
+char   *pdc_strprint(pdc_core *pdc, const char *str, int leni,
                 int maxchar, pdc_strform_kind strform);
-char    *pdc_strdup_convert(pdc_core *pdc, pdc_encoding encto,
+char   *pdc_strdup_convert(pdc_core *pdc, pdc_encoding encto,
                 pdc_encoding encfrom, const char *text, int flags,
                 const char *fn);
 const char *pdc_utf8strprint(pdc_core *pdc, const char *str);
 int	pdc_split_stringlist(pdc_core *pdc, const char *text,
                     const char *i_separstr, int flags, char ***stringlist);
-char *  pdc_substitute_variables(pdc_core *pdc, const char *string, char vchar,
+char   *pdc_substitute_variables(pdc_core *pdc, const char *string, char vchar,
            const char *delimiters, const char **varslist,
            const char **valslist, int nvars, int *errind);
 void    pdc_cleanup_stringlist(pdc_core *pdc, char **stringlist);
diff -uNr PDFlib-Lite-7.0.4/libs/pdcore/pc_xmp.c PDFlib-Lite-7.0.5/libs/pdcore/pc_xmp.c
--- PDFlib-Lite-7.0.4/libs/pdcore/pc_xmp.c	2009-06-08 17:57:28.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdcore/pc_xmp.c	2010-04-29 15:50:05.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pc_xmp.c,v 1.38.2.171 2009/04/29 19:16:44 serge Exp $
+/* $Id: pc_xmp.c,v 1.38.2.173 2009/12/22 15:03:47 serge Exp $
  *
  * The core XMP support.
  *
@@ -23,6 +23,7 @@
 
 
 
+
 
 
 
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_3d.c PDFlib-Lite-7.0.5/libs/pdflib/p_3d.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_3d.c	2009-06-08 17:57:28.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_3d.c	2010-04-29 15:50:05.000000000 +0200
@@ -9,7 +9,7 @@
  |    available, please check http://www.pdflib.com.                         |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_3d.c,v 1.5.2.11 2008/04/28 17:45:43 kurt Exp $
+/* $Id: p_3d.c,v 1.5.2.13 2010/03/02 18:59:34 kurt Exp $
  *
  * PDFlib 3D functions routines
  *
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_annots.c PDFlib-Lite-7.0.5/libs/pdflib/p_annots.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_annots.c	2009-06-08 17:57:28.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_annots.c	2010-04-29 15:50:05.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_annots.c,v 1.198.2.28 2009/02/10 16:46:54 kurt Exp $
+/* $Id: p_annots.c,v 1.198.2.30 2010/04/16 12:32:27 kurt Exp $
  *
  * PDFlib routines for annnotations
  *
@@ -695,10 +695,10 @@
 };
 
 static pdf_annot *
-pdf_new_annot(PDF *p)
+pdf_new_annot(PDF *p, pdf_annottype atype)
 {
     pdc_vtr *annots = pdf_get_annots_list(p);
-    pdf_annot *result;
+    pdf_annot *ann;
 
     if (annots == NULL)
     {
@@ -706,14 +706,16 @@
         pdf_set_annots_list(p, annots);
     }
 
-    result = pdc_vtr_incr(annots, pdf_annot);
-    result->usercoordinates = p->usercoordinates;
-    result->hypertextencoding = p->hypertextencoding;
-    result->hypertextcodepage = p->hypertextcodepage;
-    pdf_init_coloropt(p, &result->fillcolor);
+    ann = pdc_vtr_incr(annots, pdf_annot);
+    ann->atype = atype;
 
 
-    return result;
+    ann->usercoordinates = p->usercoordinates;
+    ann->hypertextencoding = p->hypertextencoding;
+    ann->hypertextcodepage = p->hypertextcodepage;
+    pdf_init_coloropt(p, &ann->fillcolor);
+
+    return ann;
 }
 
 static void
@@ -967,8 +969,7 @@
                                    &cdata, pdc_true);
 
     /* Initializing */
-    ann = pdf_new_annot(p);
-    ann->atype = atype;
+    ann = pdf_new_annot(p, atype);
 
     keyword = "usercoordinates";
     pdc_get_optvalues(keyword, resopts, &ann->usercoordinates, NULL);
@@ -1167,7 +1168,8 @@
                           ann->hypertextencoding, ann->hypertextcodepage);
 
         pdf_get_opt_textlist(p, keyword, resopts, ann->hypertextencoding,
-                             ann->hypertextcodepage, pdc_true,
+                             ann->hypertextcodepage,
+             /* bug #2344 */ atype == ann_fileattachment ? pdc_undef : pdc_true,
                              NULL, &ann->filename, NULL);
         pdc_save_lastopt(resopts, PDC_OPT_SAVE1ELEM);
 
@@ -1432,8 +1434,7 @@
                     if (ir > irect)
                     {
                         /* create copy */
-                        ann = pdf_new_annot(p);
-                        ann->atype = atype;
+                        ann = pdf_new_annot(p, atype);
                         memcpy(ann, ann_first, sizeof(pdf_annot));
                         ann->obj_id = PDC_BAD_ID;
                         ann->iscopy = pdc_true;
@@ -2166,8 +2167,9 @@
     pdc_fclose(attfile);
 
     /* fill up annotation struct */
-    ann = pdf_new_annot(p);
-    ann->atype = ann_fileattachment;
+    ann = pdf_new_annot(p, ann_fileattachment);
+    ann->zoom = pdc_false;
+    ann->rotate = pdc_false;
     pdf_init_rectangle(p, ann, llx, lly, urx, ury, NULL);
     pdf_insert_annot_params(p, ann);
     ann->filename = pdc_strdup(p->pdc, filename);
@@ -2180,8 +2182,6 @@
     if (icontype != icon_attach_pushpin)
         ann->iconname =
             pdc_get_keyword(icontype, pdf_attach_iconnames_pdfkeylist);
-    ann->zoom = pdc_false;
-    ann->rotate = pdc_false;
 }
 
 void
@@ -2210,8 +2210,7 @@
     }
 
     /* fill up annotation struct */
-    ann = pdf_new_annot(p);
-    ann->atype = ann_text;
+    ann = pdf_new_annot(p, ann_text);
     pdf_init_rectangle(p, ann, llx, lly, urx, ury, NULL);
     pdf_insert_annot_params(p, ann);
     ann->contents = pdf_convert_hypertext_depr(p, contents, len_cont);
@@ -2259,8 +2258,7 @@
     /* fill up annotation struct */
     if (acthdl > -1)
     {
-        ann = pdf_new_annot(p);
-        ann->atype = ann_link;
+        ann = pdf_new_annot(p, ann_link);
         pdf_init_rectangle(p, ann, llx, lly, urx, ury, NULL);
         pdf_insert_annot_params(p, ann);
         if (p->pdc->hastobepos) acthdl++;
@@ -2328,8 +2326,7 @@
     /* fill up annotation struct */
     if (acthdl > -1)
     {
-        ann = pdf_new_annot(p);
-        ann->atype = ann_link;
+        ann = pdf_new_annot(p, ann_link);
         pdf_init_rectangle(p, ann, llx, lly, urx, ury, NULL);
         pdf_insert_annot_params(p, ann);
         if (p->pdc->hastobepos) acthdl++;
@@ -2354,8 +2351,7 @@
     pdf_annot *ann;
 
     /* fill up annotation struct */
-    ann = pdf_new_annot(p);
-    ann->atype = ann_link;
+    ann = pdf_new_annot(p, ann_link);
     pdf_init_rectangle(p, ann, llx, lly, urx, ury, NULL);
     pdf_insert_annot_params(p, ann);
     ann->dest = pdf_parse_destination_optlist(p, optlist, page, pdf_locallink);
@@ -2387,8 +2383,7 @@
     /* fill up annotation struct */
     if (acthdl > -1)
     {
-        ann = pdf_new_annot(p);
-        ann->atype = ann_link;
+        ann = pdf_new_annot(p, ann_link);
         pdf_init_rectangle(p, ann, llx, lly, urx, ury, NULL);
         pdf_insert_annot_params(p, ann);
         if (p->pdc->hastobepos) acthdl++;
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_block.c PDFlib-Lite-7.0.5/libs/pdflib/p_block.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_block.c	2009-06-08 17:57:28.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_block.c	2010-04-29 15:50:05.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_block.c,v 1.169.2.22 2009/04/09 09:03:16 kurt Exp $
+/* $Id: p_block.c,v 1.169.2.25 2010/04/20 11:52:15 tm Exp $
  *
  * Block processing routines (require the PDI library)
  *
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_defopt.h PDFlib-Lite-7.0.5/libs/pdflib/p_defopt.h
--- PDFlib-Lite-7.0.4/libs/pdflib/p_defopt.h	2009-06-08 17:57:28.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_defopt.h	2010-04-29 15:50:05.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_defopt.h,v 1.165.2.18 2009/06/08 11:27:51 kurt Exp $
+/* $Id: p_defopt.h,v 1.165.2.19 2009/07/24 16:01:37 kurt Exp $
  *
  * PDFlib shared option definitions and structures
  *
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/pdflib.h PDFlib-Lite-7.0.5/libs/pdflib/pdflib.h
--- PDFlib-Lite-7.0.4/libs/pdflib/pdflib.h	2009-06-08 17:57:30.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/pdflib.h	2010-04-29 15:50:07.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pdflib.h,v 1.293.2.50 2009/06/08 15:36:40 rjs Exp $
+/* $Id: pdflib.h,v 1.293.2.60 2010/04/28 13:34:29 rjs Exp $
  *
  * Public function declarations for PDFlib Lite, PDFlib, PDFlib+PDI, and PPS;
  * see PDFlib API reference for details.
@@ -37,8 +37,8 @@
 
 #define PDFLIB_MAJORVERSION	7		/* major version number */
 #define PDFLIB_MINORVERSION	0       	/* minor version number */
-#define PDFLIB_REVISION		4       	/* revision number */
-#define PDFLIB_VERSIONSTRING	"7.0.4p4"       /* The whole bunch */
+#define PDFLIB_REVISION		5       	/* revision number */
+#define PDFLIB_VERSIONSTRING	"7.0.5"       /* The whole bunch */
 
 
 /*
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/pdflib.rc PDFlib-Lite-7.0.5/libs/pdflib/pdflib.rc
--- PDFlib-Lite-7.0.4/libs/pdflib/pdflib.rc	2009-06-08 17:57:26.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/pdflib.rc	2010-04-29 15:50:03.000000000 +0200
@@ -28,8 +28,8 @@
 //
 
 VS_VERSION_INFO VERSIONINFO
- FILEVERSION 7,0,4,42
- PRODUCTVERSION 7,0,4,42
+ FILEVERSION 7,0,5,0102
+ PRODUCTVERSION 7,0,5,0102
  FILEFLAGSMASK 0x3fL
 #ifdef _DEBUG
  FILEFLAGS 0x1L
@@ -47,11 +47,11 @@
             VALUE "Comments", "www.pdflib.com\0"
             VALUE "CompanyName", "PDFlib GmbH\0"
             VALUE "FileDescription", "PDFlib - a library for generating PDF on the fly\0"
-            VALUE "FileVersion", "7.0.4\0"
-            VALUE "LegalCopyright", "Copyright © 1997-2009 PDFlib GmbH\0"
+            VALUE "FileVersion", "7.0.5\0"
+            VALUE "LegalCopyright", "Copyright © 1997-2010 PDFlib GmbH\0"
             VALUE "OriginalFilename", "pdflib.dll\0"
             VALUE "ProductName", "PDFlib for Windows\0"
-            VALUE "ProductVersion", "7.0.4\0"
+            VALUE "ProductVersion", "7.0.5\0"
         END
     END
     BLOCK "VarFileInfo"
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_document.c PDFlib-Lite-7.0.5/libs/pdflib/p_document.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_document.c	2009-06-08 17:57:28.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_document.c	2010-04-29 15:50:05.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_document.c,v 1.174.2.56 2009/05/25 13:54:30 kurt Exp $
+/* $Id: p_document.c,v 1.174.2.60 2009/10/21 14:28:09 stm Exp $
  *
  * PDFlib document related routines
  *
@@ -518,6 +518,12 @@
 
 
 
+pdc_bool
+pdf_get_plainmetadata(PDF *p)
+{
+    (void) p;
+    return pdc_false;
+}
 
 
 /* ------------------------- viewerpreferences ----------------------- */
@@ -889,7 +895,7 @@
                             pdf_attachments_options, &cdata, pdc_true);
 
         if (pdf_get_opt_textlist(p, "filename", resopts, htenc, htcp,
-                                 pdc_true, NULL, &fat->filename, NULL))
+                 /* bug #2344 */ pdc_undef, NULL, &fat->filename, NULL))
             pdc_save_lastopt(resopts, PDC_OPT_SAVE1ELEM);
 
         if (pdf_get_opt_textlist(p, "description", resopts, htenc, htcp,
@@ -1155,9 +1161,7 @@
 
     pdc_get_optvalues("moddate", resopts, &doc->moddate, NULL);
 
-
-
-    ns = pdc_get_optvalues("attachments", resopts, NULL, &strlist);
+    ns = pdc_get_opt_utf8strings(p->pdc, "attachments", resopts, 0, &strlist);
     if (ns)
         pdf_parse_attachments_optlist(p, strlist, ns, htenc, htcp);
 }
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_font.c PDFlib-Lite-7.0.5/libs/pdflib/p_font.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_font.c	2009-06-08 17:57:28.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_font.c	2010-04-29 15:50:05.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_font.c,v 1.461.2.75 2009/06/08 11:23:17 kurt Exp $
+/* $Id: p_font.c,v 1.461.2.79 2009/09/24 15:00:33 kurt Exp $
  *
  * PDFlib font handling routines
  *
@@ -1760,7 +1760,9 @@
     pdc_printf(p->out, "/Ascent %d\n", font->ft.m.ascender);
     pdc_printf(p->out, "/CapHeight %d\n", font->ft.m.capHeight);
     pdc_printf(p->out, "/Descent %d\n", font->ft.m.descender);
-    pdc_printf(p->out, "/FontBBox[%d %d %d %d]\n",
+
+    if (font->ft.m.type != fnt_Type3)
+        pdc_printf(p->out, "/FontBBox[%d %d %d %d]\n",
                         (int) font->ft.m.llx, (int) font->ft.m.lly,
                         (int) font->ft.m.urx, (int) font->ft.m.ury);
 
@@ -1769,7 +1771,9 @@
     pdc_puts(p->out, "\n");
 
     pdc_printf(p->out, "/ItalicAngle %d\n", (int) (font->ft.m.italicAngle));
-    pdc_printf(p->out, "/StemV %d\n", font->ft.m.StdVW);
+
+    if (font->ft.m.type != fnt_Type3)
+        pdc_printf(p->out, "/StemV %d\n", font->ft.m.StdVW);
 
     if (font->ft.m.StdHW > 0)
         pdc_printf(p->out, "/StemH %d\n", font->ft.m.StdHW);
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_generr.h PDFlib-Lite-7.0.5/libs/pdflib/p_generr.h
--- PDFlib-Lite-7.0.4/libs/pdflib/p_generr.h	2009-06-08 17:57:28.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_generr.h	2010-04-29 15:50:05.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_generr.h,v 1.338.2.56 2009/05/25 09:31:16 tm Exp $
+/* $Id: p_generr.h,v 1.338.2.61 2010/04/16 12:32:27 kurt Exp $
  *
  * PDFlib error messages
  *
@@ -492,6 +492,9 @@
 
 gen(0, 2522, FONT_FORCEEMBED2, "Metadata requires embedding")
 
+gen(0, 2523, FONT_CORRUPT_PFA,
+    "Corrupt PFA font data (invalid hex code after 'currentfile eexec')")
+
 gen(0, 2530, CJK_UNSUPP_REGISTRY,
     "Font not supported (contains non-Adobe registry in CMap)")
 
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_hyper.c PDFlib-Lite-7.0.5/libs/pdflib/p_hyper.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_hyper.c	2009-06-08 17:57:29.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_hyper.c	2010-04-29 15:50:06.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_hyper.c,v 1.191.2.30 2009/04/17 10:46:43 kurt Exp $
+/* $Id: p_hyper.c,v 1.191.2.31 2009/10/19 15:39:40 kurt Exp $
  *
  * PDFlib routines for hypertext stuff:
  * named destination, bookmarks, document info
@@ -1405,7 +1405,8 @@
 
 
 
-    const char  *product = "PDFlib Lite";
+    const char *product = "PDFlib Lite";
+    const char *security = "";
 
     (void) logg3;
 
@@ -1462,11 +1463,11 @@
      */
 
     if (p->pdc->binding)
-        pdc_sprintf(p->pdc, pdc_false, producer, "%s %s (%s/%s)", product,
-            PDFLIB_VERSIONSTRING, p->pdc->binding, PDF_PLATFORM);
+        pdc_sprintf(p->pdc, pdc_false, producer, "%s %s%s (%s/%s)", product,
+            PDFLIB_VERSIONSTRING, security, p->pdc->binding, PDF_PLATFORM);
     else
-        pdc_sprintf(p->pdc, pdc_false, producer, "%s %s (%s)", product,
-            PDFLIB_VERSIONSTRING, PDF_PLATFORM);
+        pdc_sprintf(p->pdc, pdc_false, producer, "%s %s%s (%s)", product,
+            PDFLIB_VERSIONSTRING, security, PDF_PLATFORM);
 
     pdc_puts(p->out, "/Producer ");
     pdf_put_hypertext(p, producer);
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_image.h PDFlib-Lite-7.0.5/libs/pdflib/p_image.h
--- PDFlib-Lite-7.0.4/libs/pdflib/p_image.h	2009-06-08 17:57:29.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_image.h	2010-04-29 15:50:06.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_image.h,v 1.97.2.11 2009/05/19 08:32:29 rjs Exp $
+/* $Id: p_image.h,v 1.97.2.13 2009/08/07 15:31:37 tm Exp $
  *
  * Header file for the PDFlib image subsystem
  *
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_intern.h PDFlib-Lite-7.0.5/libs/pdflib/p_intern.h
--- PDFlib-Lite-7.0.4/libs/pdflib/p_intern.h	2009-06-08 17:57:29.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_intern.h	2010-04-29 15:50:06.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_intern.h,v 1.491.2.32 2009/06/04 11:22:04 york Exp $
+/* $Id: p_intern.h,v 1.491.2.33 2009/10/15 14:13:53 rjs Exp $
  *
  * PDFlib internal definitions
  *
@@ -539,6 +539,7 @@
 
 void pdf_cleanup_document(PDF *p);
 void pdf_fix_openmode(PDF *p);
+pdc_bool pdf_get_plainmetadata(PDF *p);
 void pdf_insert_name(PDF *p, const char *name, pdf_nametree_type type,
         pdc_id obj_id);
 pdc_id pdf_get_id_from_nametree(PDF *p, pdf_nametree_type type,
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_jpeg.c PDFlib-Lite-7.0.5/libs/pdflib/p_jpeg.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_jpeg.c	2009-06-08 17:57:29.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_jpeg.c	2010-04-29 15:50:06.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_jpeg.c,v 1.107.2.14 2007/11/23 10:34:24 kurt Exp $
+/* $Id: p_jpeg.c,v 1.107.2.16 2009/09/28 11:24:04 kurt Exp $
  *
  * JPEG processing for PDFlib
  *
@@ -918,7 +918,7 @@
                 }
 
                 /* we must create a new virtual file */
-                if (image->info.jpeg.virtfile == 0)
+                if (image->info.jpeg.virtfile == NULL)
                 {
                     /* read whole file */
                     filebase = (void *) pdc_freadall(image->fp,
@@ -929,15 +929,13 @@
                         goto PDF_JPEG_ERROR;
                     }
 
-                    /* temporary memory */
-                    pdc_insert_mem_tmp(p->pdc, filebase, 0, 0);
-
                     filename = "__jpeg__image__data__";
                 }
                 else
                 {
                     /* delete virtual file */
                     pdc__delete_pvf(p->pdc, image->info.jpeg.virtfile);
+                    image->info.jpeg.virtfile = NULL;
                 }
 
                 /* [re]create virtual file */
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_jpx.c PDFlib-Lite-7.0.5/libs/pdflib/p_jpx.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_jpx.c	2009-06-08 17:57:29.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_jpx.c	2010-04-29 15:50:06.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_jpx.c,v 1.11.2.6 2007/03/06 11:34:18 kurt Exp $
+/* $Id: p_jpx.c,v 1.11.2.8 2009/08/07 09:08:28 tm Exp $
  *
  * JPEG2000 processing for PDFlib
  *
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_page.c PDFlib-Lite-7.0.5/libs/pdflib/p_page.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_page.c	2009-06-08 17:57:29.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_page.c	2010-04-29 15:50:06.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_page.c,v 1.116.2.24 2009/06/04 11:22:04 york Exp $
+/* $Id: p_page.c,v 1.116.2.25 2010/01/14 13:56:48 kurt Exp $
  *
  * PDFlib page related routines
  *
@@ -1650,7 +1650,9 @@
     }
 
     if (pdc_get_optvalues("transparencygroup", resopts, NULL, &slist))
+    {
         pdf_set_transgroup(p, slist[0], &po->tgroup);
+    }
 
     /* the "width" and "height" options must be processed BEFORE the
     ** "mediabox" option, since the latter dominates over the formers.
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_pdi.c PDFlib-Lite-7.0.5/libs/pdflib/p_pdi.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_pdi.c	2009-06-08 17:57:29.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_pdi.c	2010-04-29 15:50:06.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_pdi.c,v 1.246.2.26 2008/07/15 13:06:43 stm Exp $
+/* $Id: p_pdi.c,v 1.246.2.27 2009/10/21 12:47:31 stm Exp $
  *
  * PDF import routines (require the PDI library)
  *
